#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

int main (int argc, char** argv)
{
  int number_of_processes;
  int my_rank;
  int mpi_error_code;

  mpi_error_code = MPI_Init(&argc, &argv);

    mpi_error_code = MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    mpi_error_code = MPI_Comm_size(MPI_COMM_WORLD, &number_of_processes);

    //This is the server process.
    if(my_rank == 0)
    {
      printf("Hello from the server!\n");
     
      mpi_error_code = MPI_Send("Hi from server!", 16, MPI_CHAR, 1, 0, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hello from server!", 19, MPI_CHAR, 1, 1, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hey from server!", 17, MPI_CHAR, 1, 2, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hi there from server!", 22, MPI_CHAR, 1, 3, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hey there from server!", 23, MPI_CHAR, 1, 4, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hey there from server2!", 24, MPI_CHAR, 1, 5, MPI_COMM_WORLD);
      mpi_error_code = MPI_Send("Hey there from server3!", 24, MPI_CHAR, 1, 6, MPI_COMM_WORLD);

      printf("Message was sent from server!\n");
    }
    else
    {
      printf("Hello from the client!\n");

      char str[25];
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 6, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 5, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 4, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 3, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 2, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
      mpi_error_code = MPI_Recv(str, 25, MPI_CHAR, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("The message received in the client is: %s\n", str);
    }

  mpi_error_code = MPI_Finalize();
  return 0;
}
