#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"

int main (int argc, char** argv)
{
  int number_of_processes;
  int my_rank;
  int mpi_error_code;

  mpi_error_code = MPI_Init(&argc, &argv);

    mpi_error_code = MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    mpi_error_code = MPI_Comm_size(MPI_COMM_WORLD, &number_of_processes);

    //There is no server process, but the ring will start with process 0.

    if(my_rank == 0)
    {
      printf("Hello from the beginning of the ring!\n");
      char str[256];
      mpi_error_code = MPI_Send("Hi from process 0", strlen("Hi from process 0")+1,
        MPI_CHAR, 1, 0, MPI_COMM_WORLD);
      mpi_error_code = MPI_Recv(str, 256, MPI_CHAR, number_of_processes-1,
        0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

      printf("Message: %s was received from process %d in process %d!\n", str,
        number_of_processes-1, my_rank);
    }
    else if(my_rank == number_of_processes-1)
    {
      char str[256];
      mpi_error_code = MPI_Recv(str, 256, MPI_CHAR, my_rank-1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

      printf("Message: %s was received from process %d in process %d!\n", str,
        my_rank-1, my_rank);
      
      sprintf(str, "Hi from process %d", my_rank);
      mpi_error_code = MPI_Send(str, strlen(str)+1, MPI_CHAR, 0, 0, MPI_COMM_WORLD);
    }
    else
    {
      char str[256];
      mpi_error_code = MPI_Recv(str, 256, MPI_CHAR, my_rank-1, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

      printf("Message: %s was received from process %d in process %d!\n", str,
        my_rank-1, my_rank);
      
      sprintf(str, "Hi from process %d", my_rank);
      mpi_error_code = MPI_Send(str, strlen(str)+1, MPI_CHAR, my_rank+1, 0, MPI_COMM_WORLD);
    }

  mpi_error_code = MPI_Finalize();
  return 0;
}
